﻿using System;
using System.IO;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Navigation;

namespace Chapter_10_VSPrimer
{
	public partial class GrandChildControl
	{
		public GrandChildControl()
		{
			this.InitializeComponent();

			// Insert code required on object creation below this point.
		}

        /// <summary>
        /// Handles the Click event of the btnEventTest control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.Windows.RoutedEventArgs"/> instance containing the event data.</param>
        private void btnEventTest_Click(object sender, RoutedEventArgs e)
        {
            RoutedEventArgs newEvent = new RoutedEventArgs(GrandChildControl.TestButtonClickedEvent);
            RaiseEvent(newEvent);
        }
                
        public static readonly RoutedEvent TestButtonClickedEvent = EventManager.RegisterRoutedEvent(
            "TestButtonClicked", 
            RoutingStrategy.Bubble, 
            typeof(RoutedEventHandler), 
            typeof(GrandChildControl));

        // Provide CLR accessors for the event
        /// <summary>
        /// Occurs when [test button clicked].
        /// </summary>
        public event RoutedEventHandler TestButtonClicked
        {
            add { AddHandler(TestButtonClickedEvent, value); }
            remove { RemoveHandler(TestButtonClickedEvent, value); }
        }

	}
}