﻿using System;
using System.IO;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Navigation;

namespace Chapter13_TemplateBinding
{
	public partial class Window1
	{
		public Window1()
		{
			this.InitializeComponent();
			
			// Insert code required on object creation below this point.
		}

        private byte RedValue = 0;
        private byte GreenValue = 0;
        private byte BlueValue = 0;
        private byte AlphaValue = 0;


        private void txtRed_TextChanged(object sender, TextChangedEventArgs e)
        {
            this.RedValue = this.ValidateColorValue(this.txtRed.Text);
            this.txtRed.Text = this.RedValue.ToString();

            //Create the color and assign it to the ball
            this.CreateBackgroundColor();
        }

        private void txtGreen_TextChanged(object sender, TextChangedEventArgs e)
        {
            this.GreenValue = this.ValidateColorValue(this.txtGreen.Text);
            this.txtGreen.Text = this.GreenValue.ToString();

            //Create the color and assign it to the ball
            this.CreateBackgroundColor();
        }

        private void txtBlue_TextChanged(object sender, TextChangedEventArgs e)
        {
            this.BlueValue = this.ValidateColorValue(this.txtBlue.Text);
            this.txtBlue.Text = this.BlueValue.ToString();

            //Create the color and assign it to the ball
            this.CreateBackgroundColor();
        }

        private void txtAlpha_TextChanged(object sender, TextChangedEventArgs e)
        {
            this.AlphaValue = this.ValidateColorValue(this.txtAlpha.Text);
            this.txtAlpha.Text = this.AlphaValue.ToString();

            //Create the color and assign it to the ball
            this.CreateBackgroundColor();
        }

        /// <summary>
        /// Validates the provided string number and converts it to an byte
        /// </summary>
        /// <param name="InputValue">The value to validate</param>
        /// <returns></returns>
        private byte ValidateColorValue(string InputValue)
        {
            byte ValidateValue = Convert.ToByte(InputValue);

            if (ValidateValue < 0)
                return 0;

            if (ValidateValue > 255)
                return 255;

            return ValidateValue;
        }

        /// <summary>
        /// Create the new Brush object using the global values
        /// </summary>
        private void CreateBackgroundColor()
        {
            SolidColorBrush NewColorBrush = new SolidColorBrush();
            NewColorBrush.Color = Color.FromArgb(this.AlphaValue, this.RedValue, this.GreenValue, this.BlueValue);
            
            //Assing the Brush to the correct proeprty
            this.myBall.Fill = NewColorBrush;
        }
	}
}