﻿using System;
using System.IO;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Navigation;

namespace Chapter_17_Windows
{
	public partial class Window2
	{
		public Window2()
		{
			this.InitializeComponent();
			
			// Insert code required on object creation below this point.
		}

        public static readonly RoutedEvent WindowStateChangedEvent = EventManager.RegisterRoutedEvent(
           "WindowStateChanged", RoutingStrategy.Bubble, typeof(RoutedEventHandler), typeof(Window2));

        // Provide CLR accessors for the event
        public event RoutedEventHandler WindowStateChanged
        {
            add { AddHandler(WindowStateChangedEvent, value); }
            remove { RemoveHandler(WindowStateChangedEvent, value); }
        }


        public enum WINDOW_STATE
        {
            Closed = 0,
            Loaded = 1
        }

        private void Window_Closed(object sender, EventArgs e)
        {
            this.RaiseStateChange(WINDOW_STATE.Closed);
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            this.RaiseStateChange(WINDOW_STATE.Loaded);
        }



        private void RaiseStateChange(WINDOW_STATE CurrentState)
        {
            RoutedEventArgs newEvent = new RoutedEventArgs(Window2.WindowStateChangedEvent, CurrentState);
            RaiseEvent(newEvent);
        }
	}
}