﻿using System;
using System.IO;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Navigation;

namespace Chapter_05_TreeViewDemo
{
	public partial class TreeItem
	{
		public TreeItem()
		{
			this.InitializeComponent();

			// Insert code required on object creation below this point.
		}

        /// <summary>
        /// Button State choices
        /// </summary>
        public enum ButtonState
        {
            NotDeterminate = 0,
            Determinate = 1
        }

        //Default set
        private ButtonState _currentState = ButtonState.NotDeterminate;

        /// <summary>
        /// Get or set the current button state
        /// </summary>
        public ButtonState CurrentState
        {
            get { return _currentState; }
            set { _currentState = value; }
        }

        private void btnIndeterminate_Click(object sender, RoutedEventArgs e)
        {
            switch (CurrentState)
            {
                case ButtonState.NotDeterminate:
                    this.CurrentState = ButtonState.Determinate;
                    this.btnIndeterminate.Content = "Determinate";
                    this.pbRunner.IsIndeterminate = true;
                    break;
                case ButtonState.Determinate:
                    this.CurrentState = ButtonState.NotDeterminate;
                    this.btnIndeterminate.Content = "Not Determinate";
                    this.pbRunner.IsIndeterminate = false;
                    break;
                default:
                    break;
            }

        }

        public void SetLabelValue(String ValueToShow)
        {
            this.labChildName.Content = ValueToShow;
        }

	}
}