﻿using System;
using System.IO;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Navigation;

namespace Chapter_05_TreeViewDemo
{
	public partial class Window1
	{
		public Window1()
		{
			this.InitializeComponent();
			
			// Insert code required on object creation below this point.
		}

        private void btnAddChild_Click(object sender, RoutedEventArgs e)
        {
            int LoopCount = Convert.ToInt32(this.txtItemCount.Text);

            //Make sure we have at least 1 to add
            if (LoopCount == 0)
            {
                this.txtItemCount.Text = "1";
                LoopCount = 1;
            }

            //Create a new TreeItem to add to the control
            TreeViewItem TempItem = new TreeViewItem();

            //Create a single Header that will show the time it was created
            TreeHeader MyHeader = new TreeHeader();
            MyHeader.SetLabelContent("Item added: " + DateTime.Now.ToLongDateString() + " " + DateTime.Now.ToLongTimeString());
            MyHeader.MinWidth = 300;

            //Add the header to the control before we start to add child items
            TempItem.Header = MyHeader;

            //Add child elements
            for (int LoopValue = 0; LoopValue < LoopCount; LoopValue++)
            {
                //Create and add an item to our TreeViewItem
                TreeItem TempTreeItem = new TreeItem();
                TempTreeItem.SetLabelValue(Convert.ToString(LoopValue + 1) + " of " + LoopCount.ToString() + " children");
                TempTreeItem.MinWidth = 500;
                TempItem.Items.Add(TempTreeItem);

                TempTreeItem = null;
            }

            //Add our item to the TreeView control. If an item or header is selected,
            //add out item as a child of it
            if (this.tvMain.SelectedItem != null)
            {
                if (this.tvMain.SelectedItem is TreeItem)
                {
                    TreeViewItem SelectedItem = (this.tvMain.SelectedItem as TreeItem).Parent as TreeViewItem;
                    this.tvMain.BeginInit();
                    SelectedItem.Items.Add(TempItem);
                    this.tvMain.EndInit();
                }
                else if (this.tvMain.SelectedItem is TreeHeader)
                {
                    TreeViewItem SelectedItem = (this.tvMain.SelectedItem as TreeHeader).Parent as TreeViewItem;
                    this.tvMain.BeginInit();
                    SelectedItem.Items.Add(TempItem);
                    this.tvMain.EndInit();
                }
                else if (this.tvMain.SelectedItem is TreeViewItem)
                {
                    TreeViewItem SelectedItem = this.tvMain.SelectedItem as TreeViewItem;
                    this.tvMain.BeginInit();
                    SelectedItem.Items.Add(TempItem);
                    this.tvMain.EndInit();
                }

            }
            else
            {
                this.tvMain.BeginInit();
                this.tvMain.Items.Add(TempItem);
                this.tvMain.EndInit();
            }

        }
	}
}